;;; Gacela, a GNU Guile extension for fast games development
;;; Copyright (C) 2016 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (gacela utils)
  #:export (make-producer))

(define (make-producer body)
  (define resume #f)
  (lambda (real-send)
    (define send-to real-send)
    (define (send value-to-send)
      (set! send-to
	(call/cc
	 (lambda (k)
	   (set! resume k)
	   (send-to value-to-send)))))
    (if resume
	(resume real-send)
	(body send))))
